SystemOrganization addCategory: #Metaprogramacion!

TestCase subclass: #MetaprogramacionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/21/2013 20:01'!
abstractMethodForWhomAllOfItsClassOneLevelSubclassesHaveDefinedIt
	^ SampleClassWithOneLevelOfSubclasses>>#aSubclassDefinedMethod! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/21/2013 20:01'!
abstractMethodForWhomItsClassHasNotSubclasses
	^ SampleClassWithNoSubclasses>>#anAbstractMethod! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/21/2013 18:51'!
nonAbstractCompiledMethod
	^ SampleClassToTestProgrammingErrorsDetector>>#nonAbstractMethod! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/21/2013 18:28'!
test01IfAMethodIsNotAbstractThenItWillBeConsideredDefined

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self nonAbstractCompiledMethod).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self nonAbstractCompiledMethod) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/21/2013 18:57'!
test02IfAMethodIsAbstractAndThereIsNotSubclassesThenItIsUndefinedForSubclassesAndTheListOfSublcassesForWhomIsUndefinedMustBeEmpty

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self assert: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self abstractMethodForWhomItsClassHasNotSubclasses).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self abstractMethodForWhomItsClassHasNotSubclasses) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/21/2013 19:59'!
test03IfAMethodIsAbstractAndAllSubclassesDefineItThenIsDefinedAndTheListOfSublcassesMustBeEmpty

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self abstractMethodForWhomAllOfItsClassOneLevelSubclassesHaveDefinedIt).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self abstractMethodForWhomAllOfItsClassOneLevelSubclassesHaveDefinedIt) isEmpty.! !

Object subclass: #ProgrammingErrorsDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/21/2013 21:05'!
allLeavesSubClasses: aClass
	^ aClass allSubclasses select: [:aSubClass | aSubClass subclasses isEmpty]! !

!ProgrammingErrorsDetector methodsFor: 'finders' stamp: 'AlejandraRodriguez 6/21/2013 18:41'!
allSubclassesForWhomIsUndefinedTheMethod: aMetaprogramacionTests 
	^ OrderedCollection new.! !

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/21/2013 20:58'!
isAbstractClass: aClass
	^ (aClass allMethods select: [:aMethod | aMethod isAbstract]) isEmpty  not! !

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/21/2013 21:09'!
isLeaveSubClass: aClass
	^ aClass subclasses isEmpty! !

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/21/2013 21:07'!
methodIsUndefinedForSubclases: aCompiledMethod 
	^ aCompiledMethod isAbstract and: (self theSubclasesNotDefineTheMethod: aCompiledMethod)! !

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/21/2013 21:28'!
theSubclasesNotDefineTheMethod: aCompiledMethod
	|theMethodSelector |
	theMethodSelector := aCompiledMethod selector.
	^ (self allLeavesSubClasses: aCompiledMethod methodClass) allSatisfy: [ :aLeaveSubClass | (aLeaveSubClass allMethods keyAtValue: theMethodSelector)>>theMethodSelector isAbstract ]
! !

Object subclass: #SampleClassToTestProgrammingErrorsDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassToTestProgrammingErrorsDetector methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 18:39'!
nonAbstractMethod
	^ 'Soy un mtodo no abstracto. =D'! !

!SampleClassToTestProgrammingErrorsDetector methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 20:30'!
sipoAbstractMethod
	^ self subclassResponsibility ! !

SampleClassToTestProgrammingErrorsDetector subclass: #SampleClassWithNoSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassWithNoSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 18:49'!
anAbstractMethod
	^ self subclassResponsibility ! !

SampleClassToTestProgrammingErrorsDetector subclass: #SampleClassWithOneLevelOfSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassWithOneLevelOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ self subclassResponsibility ! !

!SampleClassWithOneLevelOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 20:26'!
anAbstractMethod
	^ self subclassResponsibility ! !

SampleClassWithOneLevelOfSubclasses subclass: #SampleOneLevelSubClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleOneLevelSubClassA methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:52'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleClassWithOneLevelOfSubclasses subclass: #SampleOneLevelSubClassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleOneLevelSubClassB methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:53'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleClassToTestProgrammingErrorsDetector subclass: #SampleClassWithTwoLevelsOfSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassWithTwoLevelsOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ self subclassResponsibility ! !

SampleClassWithTwoLevelsOfSubclasses subclass: #SampleTwoLevelSubclassWhitOneSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

SampleTwoLevelSubclassWhitOneSubclass subclass: #SampleSubSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleTwoLevelSubclassWhitOneSubclass methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleClassWithTwoLevelsOfSubclasses subclass: #SampleTwoLevelSubclassWithTwoSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

SampleTwoLevelSubclassWithTwoSubclasses subclass: #SampleSubSubclassD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleSubSubclassD methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleTwoLevelSubclassWithTwoSubclasses subclass: #SampleSubSubclassE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleSubSubclassE methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !
